--  eidolon -- A simple gallery in Haskell and Yesod
--  Copyright (C) 2015  Amedeo Molnár
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU Affero General Public License for more details.
--
--  You should have received a copy of the GNU Affero General Public License
--  along with this program.  If not, see <http://www.gnu.org/licenses/>.

module Handler.Admin where

import Import
import Data.List (tail)
import Handler.Commons
-- import Database.Bloodhound

getAdminR :: Handler Html
getAdminR = do
  adminCheck <- loginIsAdmin
  case adminCheck of
    Right _ ->
      defaultLayout $ do
        setTitle "Administration: Menu"
        $(widgetFile "adminBase")
    Left (errorMsg, route) -> do
      setMessage errorMsg
      redirect route

getAdminRepopThumbsR :: Handler Html
getAdminRepopThumbsR = do
  adminCheck <- loginIsAdmin
  case adminCheck of
    Right _ -> do
      media <- runDB $ selectList [] [Asc MediumId]
      mapM_ (\(Entity _ m) -> generateThumbs
        (tail $ mediumPath m)
        (mediumOwner m)
        (mediumAlbum m)
        (mediumMime m)
        ) media
      setMessage "Repopulation successfull"
      redirect AdminR
    Left (emsg, route) -> do
      setMessage emsg
      redirect route
